%ext ck4
%version 1.4


# Load the modified graphics
%egahead EGAHEAD.CK4
%maphead MAPHEAD.CK4
%gamemaps GAMEMAPS.CK4
%patchfile $249C2 "Keen4.tli"



###GENERAL###
%patch $CC2A $83 $3E $A7EDW $0D $75 $30 #water @13
%patch $60FD $0F $77                   	#re-entry @16
%patch $9058 $A7EDW $0D $74		#float scroll @13
%patch $D1FA $CAB5W $00 $75 $1F $C7 $06 $7A70W $0002W	#Moon to win
%patch $11792 $E9 $3B $01 		#clean platforms
%patch $105B0 $90 $90 $90 $90 $90  	#arachnut
%patch $123F9 $EB			#Lethargic Dopefish
%patch $E208 $7A5CW $00 $74		#Always "swim" on map

###STATUS WINDOW##
%patch $8058 $EB $4D 			#Wetsuit
%patch $80BE $0078W			#Wetsuit
%patch $80DC $0078W			#Wetsuit
%patch $7E32 $90 $90 $90 $90 $90	#Council
%patch $7E4D $90 $90 $90 $90 $90	#Council
%patch $7E6D $90 $90 $90 $90 $90	#Council
%patch $2F4CB "COINS" $00		#coins

###NON-GAMEPLAY-RELATED###
%patch $3CBB $04D1W			#disable demos
%patch $3CBF $04D1W			#disable demos
%patch $3CC3 $04D1W			#disable demos
%patch $3CC5 $04D1W			#disable demos
%patch $3CBD $04D1W			#disable star wars
%patch $33CCA "RETURN TO GAME" $00 "HIGH SCORES   " $00


###WETSUIT/END OF GAME CONDITION###
%patch $6BD9 $0EB2W			#state 13 wins game
%patch $12A62 $C7 $06 $7A70W $000DW	#Wetsuit sets state 13
%patch $30A4B "The jig is up." $0A "You're coming with me."



###ELVIS#####
%patch $3094C	"Need a passcode?" $0A "Try 7-3-0-9." $0A "Uh huh huh!" $0A "" $0A $00
%patch $30999 	"Plants on this island" $0A
		"store nutrients by  " $0A
		"extruding sucrose  " $0A
		"rods. " $0A $00
%patch $309E3	"Wow, you ARE the king!" $00
%patch $309FA	"Sure looks like" $0A
		"candy to me..." $0A $0A $00


###LEVEL 0###
%patch $1F040 "Meurglys III   " $00
%patch $1F1F0 "Keen explores " $0A "Meurglys III" $00
%patch $2F191 "Exit to Meurglys III" $00

%patch $DE43 $29			#Foot location A 
%patch $DE58 $26
%patch $DE78 $31			#Foot location B 
%patch $DE8C $43
%patch $DE36 $7A1AW $3000W $73		#Foot threshold

%patch $FAF8 $0050W			#Animations
%patch $FB21 $0050W
%patch $FB49 $0050W
%patch $FB71 $0050W
%patch $FB99 $0050W
%patch $FBC1 $0050W
%patch $FBE9 $0050W
%patch $FC11 $0050W


###LEVEL 1###
%patch $1F050 "   Fern Town   " $00
%patch $1F210 "Keen gets his game on" $0A "in Fern Town" $00

###LEVEL 2###
%patch $1F060 "Two Line Temple" $00
%patch $1F240 "Keen crosses" $0A "Two Line Temple" $00

###LEVEL 3###
%patch $1F070 "Time Temple    " $00
%patch $1F260 "Keen winds his watch" $0A "in the Time Temple" $00            

###LEVEL 4###
%patch $1F090 "Air Quality Monitoring Stn" $00
%patch $1F290 "Keen catches his breath" $0A "in the Air Quality" $0A  "Monitoring Station" $0A            

###LEVEL 5###
%patch $1F0B0 "CANDY ISLAND!" $00
%patch $1F2D0 "Keen gets a sugar rush" $0A "on CANDY ISLAND!" $00

###LEVEL 6###
%patch $1F0C0 "Mount Meurglys " $00
%patch $1F300 "Keen attempts to" $0A "scale Mount Meurglys" $00

###LEVEL 7###
%patch $1F0D0 "King's Canyon" $00
%patch $1F330 "Keen surveys" $0A "King's Canyon" $00
%patch $30A25 "Elvis says:" $0A $00


###LEVEL 8###
%patch $1F0E0 "Twisted Temple " $00
%patch $1F350 "Keen gets turned around" $0A "in Twisted Temple     " $00

###LEVEL 9 INTENTIONALLY LEFT EMPTY###

###LEVEL 10###
%patch $1F100 "Bottling Plant " $00
%patch $1F3A0 "Keen cools off in the" $0A "Iced Tea Bottling Plant " $00

###LEVEL 11###
%patch $1F110 "Orbital Hideout" $00
%patch $1F3D0 "Keen charges into" $0A "Rick's Orbital Hideout"

###LEVEL 12###
%patch $1F400 "Keen inspects the" $0A "Sewage Plant (Upstairs)" $00 
%patch $1F130 "Sewage Plant (Upstairs)" $00


###LEVEL 13###
%patch $1F430 "Keen cannonballs into" $0A "the Sewage Plant" $0A "(Downstairs)" $00 
%patch $1F150 "Sewage Plant" $0A "(Downstairs)" $00

###LEVEL 14###
%patch $1F180 "Witch Doctor's Hut        " $00
%patch $1F470 "Keen sceptically enters" $0A "the Witch Doctor's Hut " $0A "               " $00
%patch $FD54 $CB 			#witch doctor doesn't stop to think
%patch $1F580 	"Whoa there young fella!" $0A
              	"Drink this potion. It'll" $0A
              	"fortify you for your" $0A
		"quest." $00
%patch $1F5E0 	"It has a bit of a kick" $0A
              	"on it, so be careful." $0A
              	"" $0A
		"" $00
%patch $1F630 	"I'm not sure about" $0A
		"this."	 $00
%patch $1F650 	"There you go, down the" $0A
              	"hatch! How's the taste?" $00

###LEVEL 15###
%patch $1F4B0 "Keen takes his chances" $0A "in Badluck Cave" $00
%patch $1F1A0 "Badluck Cave" $00

###LEVEL 16###
%patch $1F1B0 "A Peculiar Cave" $00
%patch $1F4E0 "Keen peers into a" $0A "Peculiar Cave" $00

###LEVEL 17###
%patch $1F1C0 "Sculpture Garden" $00
%patch $1F510 "Keen kicks up dust" $0A "in the Sculpture Garden" $0A


%PATCH $7893 $5E $5D $CB
%PATCH $2f435 	"Cheat option!" $0A $0A
		"You just got 99" $0A
		"Shots and a 1-UP." $0A
		"No keys though!" $00

###AUDIO###
%patchfile $20DF0 AUDIOHED.CK4	#Audio header
%patchfile $354F6 AUDIODCT.CK4	#Audio dictionary
%patch $8CEF $9B $00
%patch $8C75 $C893W
%patch $8C83 $C893W
%patch $8D83 $C893W
%patch $2F206	$0000W	$0003W	$0004W	$0004W
		$0002W	$0003W	$0003W	$0003W
		$0004W	$0000W	$0004W	$0001W	 
		$0002W	$0002W	$0001W	$0004W
		$0005W	$0005W	$0005W	$FFFFW		
#0=longway
#1=verdi
#2=bigsky
#3=radar
#4=direstrt
#5=bonzo



################################################################################
# Version Info
################################################################################

%patch $20D71	# Keen 4 startup screen
	"U" $1B
	"n" $1B
	"o" $1B
	"f" $1B
	"f" $1B
	"i" $1B
	"c" $1B
	"i" $1B
	"a" $1B
	"l" $1B
	" " $1B
	"B" $1B
	"u" $1B
	"g" $1B
	"f" $1B
	"i" $1B
	"x" $1B
	" " $1B
	"R" $1B
	"e" $1B
	"l" $1B
	"e" $1B
	"a" $1B
	"s" $1B
	"e" $1B
	" " $1B
	"(" $1B
	"2" $1B
	"0" $1B
	"2" $1B
	"0" $1B
	"-" $1B
	"0" $1B
	"9" $1B
	"-" $1B
	"2" $1B
	"1" $1B
	")" $1B

# make sure final intro pic stays off-screen at the end of the intro:
%patch $42AF $FF00w

# never show the text-based exit screen (batch file uses /NOWAIT anyway):
%patch $3AA2 $EB	# turn "jnz" into "jmp"
# don't load the exit screen
%patch $3A0B $EB	# turn "jnz" into "jmp"


################################################################################
# Customized Screen Update Code For KEEN4 v1.4 (EGA)
# Copyright (c) 2019 K1n9_Duk3
#
# This software is provided 'as-is', without any express or implied warranty. In
# no event will the authors be held liable for any damages arising from the use
# of this software.
#
# Permission is granted to anyone to use this software for any purpose, including
# commercial applications, and to alter it and redistribute it freely, subject to
# the following restrictions:
#
# 1. The origin of this software must not be misrepresented; you must not claim
#    that you wrote the original software. If you use this software in a product,
#    an acknowledgment in the product documentation would be appreciated but is
#    not required.
#
# 2. Altered source versions must be plainly marked as such, and must not be
#    misrepresented as being the original software.
#
# 3. This notice may not be removed or altered from any source distribution.
################################################################################

#replace the v1.4 delay code with my custom VW_SetScreen code
#(my VW_SetScreen is bigger than the one in v1.4)
%patch $1E7F9
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$BA $03DAw		#	mov	dx, 3DAh
	$FA			#	cli
				#@l1:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$74 $FB			#	jz	@l1
				#@l2:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$75 $FB			#	jnz	@l2
	$8B $4E $06		#	mov	cx, [bp+arg_start]
	$BA $03D4w		#	mov	dx, 3D4h
	$B0 $0C			#	mov	al, 0Ch
	$EE			#	out	dx, al
	$42			#	inc	dx
	$8A $C5			#	mov	al, ch
	$EE			#	out	dx, al
	$4A			#	dec	dx
	$B0 $0D			#	mov	al, 0Dh
	$EE			#	out	dx, al
	$8A $C1			#	mov	al, cl
	$42			#	inc	dx
	$EE			#	out	dx, al
	$F7 $06 $7A14w $0001w	#	test	fixjerky, 1
	$74 $03			#	jz	@l3
	$E8 $0053w		#	call	WaitVBL
				#@l3:
	$F7 $06 $7ADEw $0001w	#	test	nopan, 1
	$75 $0C			#	jnz	l4
	$BA $03C0w		#	mov	dx, 3C0h
	$B0 $33			#	mov	al, 33h
	$EE			#	out	dx, al
	$EB $00			#	jmp	$
	$8A $46 $08		#	mov	al, [bp+arg_pan]
	$EE			#	out	dx, al
				#@l4:
	$F7 $06 $7A14w $0001w	#	test	fixjerky, 1
	$75 $03			#	jnz	@l5
	$E8 $0034w		#	call	WaitVBL
				#@l5:
	$FB			#	sti
	$5D			#	pop	bp
	$CB			#	retf

#replace the start of VW_SetScreen with a jump into my new code (see above):
%patch $1E87A
	$E9 $FF7Cw

#and overwrite the rest of the old VW_SetScreen code with my WaitVBL code:
	$8B $1E $A53Dw		#	mov	bx, word ptr TimeCount
	$BA $03DAw		#	mov	dx, 3DAh
				#@wait:	
	$FB			#	sti
	$EB $00			#	jmp	short $
	$FA			#	cli
	$EC			#	in	al, dx
	$A8 $08			#	test	al, 8
	$75 $0A			#	jnz	@done
	$A1 $A53Dw		#	mov	ax, word ptr TimeCount
	$2B $C3			#	sub	ax, bx
	$3D $0001w		#	cmp	ax, 1
	$76 $ED			#	jbe	@wait
				#@done:
	$C3			#	retn

################################################################################
# End of Customized Screen Update Code
################################################################################


##############################
# Load Audio Chunks Directly #
##############################

# This patch forces the game to load the audio data directly from the file into
# the final buffer without doing any Huffman decompression. This requires the
# AUDIO.CK4 file to be compressed with a "dummy" Huffman dictionary.
#
# Without this code, the game would load the "compressed" data into a temporary
# buffer and then decompress it into the final buffer. That means the memory
# requirements for music are more than TWICE(!) the size of the IMF song.

%patch $13466
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$FF $76	$FE		#	push	bp+var_2
	$FF $76 $FC		#	push	bp+var_4
	$FF $36 $CB9Dw		#	push	audiohandle
	$9A $00001BC9rl		#	call	_lseek
	$83 $C4 $08		#	add	sp, 8
	$B8 $0004w		#	mov	ax, 4
	$50			#	push	ax
	$B8 $CB95w		#	mov	ax, offset chunkexplen
	$50			#	push	ax
	$FF $36 $CB9Dw		#	push	audiohandle
	$9A $00001F10rl		#	call	_read
	$83 $C4 $06		#	add	sp, 6
	$FF $36 $CB97w		#	push	word ptr chunkexplen+2
	$FF $36 $CB95w		#	push	word ptr chunkexplen
	$8B $C6			#	mov	ax, si
	$D1 $E0			#	shl	ax, 1
	$05 $C75Dw		#	add	ax, offset audiosegs
	$50			#	push	ax
	$9A $155E0712rl		#	call	MM_GetPtr
	$83 $C4 $06		#	add	sp, 6
	$83 $3E $A7EFw $00	#	cmp	mmerror, 0
	$75 $1E			#	jnz	done
	$FF $36 $CB97w		#	push	word ptr chunkexplen+2
	$FF $36 $CB95w		#	push	word ptr chunkexplen
	$8B $DE			#	mov	bx, si
	$D1 $E3			#	shl	bx, 1
	$FF $B7 $C75Dw		#	push	audiosegs[bx]
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$FF $36 $CB9Dw		#	push	audiohandle
	$0E			#	push	cs
	$E8 $F68Bw		#	call	near ptr CA_FarRead
	$83 $C4 $0A		#	add	sp, 10
				#done:
	$5E			#	pop	si
	$8B $E5			#	mov	sp, bp
	$5D			#	pop	bp
	$CB			#	retf

# With this code, the huffman tree for the audio data is no longer needed,
# so let's prevent the engine from "optimizing" the huffman tree. This frees
# up 1024 bytes in the data segment, great for adding new (near) strings or
# new object state definitions.

# Free up 1024 bytes at $354F6 (dseg:6686):
%patch $13373 $EB $0F

	
########################################
# Free Graphics Before Loading A Level #
########################################

#Free sprites and tiles before loading a level
%patch $61DD
	$74 $0A			#	jz	no_demo
	$C7 $06 $7A6Cw $0002w	#	mov	gamestate_difficulty, 2
	$33 $C0			#	xor	ax, ax
	$EB $03			#	jmp	init_rndt
				#no_demo:
	$B8 $0001w		#	mov	ax, 1
				#init_rndt:
	$50			#	push	ax
	$9A $1D020002rl		#	call	US_InitRndT
	$58			#	pop	ax
	$9A $05C40006rl		#	call	FreeUpMemory
	$90 $90 $90 $90 $90 $90

#Don't free the paddle war sprites (in case loading a game fails)
%patch $5C4B $0081w	# default: $007Cw

##################
# Memory Related #
##################

# Fix error in XMS size calculation
%patch $157C2
	$BB $0010w	#	mov	bx, 16
	$F7 $E3		#	mul	bx
	$01 $06 $A017w	#	add	..., ax
	$11 $16 $A019w	#	adc	..., dx


# Lock text buffers to avoid "PageLayout: Text not headed with ^P" error

# CacheAndLock routine (returns grsegs offset in AX):
%patch $18793
	$55		#	push	bp
	$8B $EC		#	mov	bp, sp
	$57		#	push	di
	$8B $7E $06	#	mov	di, [bp+arg_0]
	$57		#	push	di
	$9A $12A61117rl	#	call	CA_CacheGrChunk
	$58		#	pop	ax
	$B8 $0001w	#	mov	ax, 1
	$50		#	push	ax
	$D1 $E7		#	shl	di, 1
	$81 $C7 $7AEDw	#	add	di, offset grsegs
	$57		#	push	di
	$9A $155e0AD5rl	#	call	MM_SetLock
	$83 $C4 $04	#	add	sp, 4
	$8B $C7		#	mov	ax, di
	$5F		#	pop	di
	$5D		#	pop	bp
	$CB		#	retf
# Note: this overwrites the unused SDL_TimingService code (2 bytes left unused)

# Use CacheAndLock instead of CA_CacheGrChunk to cache the text chunks
%patch $9BA8 $18740053rl	# for the help texts
%patch $9CBC $18740053rl	# for the ending text


# Make CA_UpLevel flow into CA_ClearMarks so we don't load more	than we need
%patch $13F4B $EB $30



###################
# Fix Engine Bugs #
###################

# Avoid crashing when trying to draw characters that don't exist in the font:
%patch $354EA $08BBw


# Make VW_ClearVideo abort if screenseg is NULL:
%patch $1D383
	$83 $3E $A7AEw $00	#	cmp	screenseg, 0
	$74 $26			#	jz	done
	$B8 $0000w		#	mov	ax, 0
#this patch overwrites some code that effectively sets AX to 0, that's why the
#new code also sets AX to 0 at the end


%end